/*
 ---------------------------------------------------------------
 Copyright (c) 2006, ixi software.
 This work is licensed under a Creative Commons 
 Attribution-NonCommercial-ShareAlike 2.0 England & Wales License.
 http://creativecommons.org/licenses/by-nc-sa/2.0/uk/
 --------------------------------------------------------------- 
 */


CircleBounce c, d;

void setup() { // just when starting up
  frameRate(20); // fps
  size(300, 200); // window size
  background(100); // bg color
  noStroke();
  //changeColor();
  
  color col = color(255, 255,255); // so it will be white until it bounces first time
  c = new CircleBounce(col);
  
  // d = new CircleBounce();
}


color randRGB(){ // returns data type color
  return color(random(255), random(255), random(255));
}


void draw(){ // this is our main loop
  background(100);
  c.circleBounceDraw();
  //d.draw();
}


class CircleBounce{
  float x = 1;
  float y = random(50,150);
  float deltaX = random(1,5);
  float deltaY = random(1,5);
  color c; // just declare because we are going to initialise it as a parameter

  CircleBounce(color aColor){ // yhis is the constructor of the class, up to now it was hidden because we didnt need it
    c = aColor; // property c takes the value passed via parameter aColor when initialising the class instance
  }

  void changeMyColor(){
    c = randRGB();
  }

  void circleBounceDraw(){
    fill(c); // asign my color
    ellipse(x, y, 55, 55);
    
    x = x + deltaX; 
    y = y + deltaY; 
    if (x >= 300 || x <= 0){
      deltaX = -deltaX; //change X direction
      changeMyColor();
    }
    if (y >= 200 || y <= 0){
      deltaY = -deltaY; //change Y direction
      changeMyColor();
    }
  }
}


